//import some modules from d3
import { select, json, geoPath, geoEquirectangular } from 'd3';
//import feature from TopoJSON that creates GeoJSON objects
import { feature } from 'topojson';

//access svg element using select()
const svg = select('svg');

//creating projection and pathGenerator constants for creation of maps
//'geoEquirectangular()' function gives a view the world map 
const projection = geoEquirectangular();
//projecting the world map using geoPath().projection
const pathGenerator = geoPath().projection(projection);

//add the path element to the created SVG
//define an attribute as 'earth'
//Taking pathGenerator type as 'Sphere'
svg.append('path')
    .attr('class', 'earth')
    .attr('d', pathGenerator({type: 'Sphere'}));

//.json file contains the info required to visualise world map
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
    const countries = feature(data, data.objects.countries); //creating countries constant
//'selectAll()' is used to select all the element which meet the string specific
    svg.selectAll('path').data(countries.features)
//enter() creates data to elements by joining them
//defines class called 'countries'
      .enter().append('path')
        .attr('class', 'countries')
        .attr('d', pathGenerator);
  });